<template>
  <CForm
    class="item-search-form"
    @submit.prevent="onSubmit"
  >
    <div class="row">
      <div class="col-12 col-xl-6">
        <CSelect
          v-model="category"
          :value.sync="category"
          label="カテゴリ"
          horizontal
          :options="[
            { value: 1, label: 'Category 1' },
            { value: 2, label: 'Category 2' }
          ]"
          placeholder="選んでください"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'th-list']" class="width-1x" />
          </template>
        </CSelect>
      </div>

      <div class="col-12 col-xl-6">
        <CSelect
          v-model="type"
          :value.sync="type"
          label="分類"
          horizontal
          :options="[
            { value: 1, label: 'Type 1' },
            { value: 2, label: 'Type 1' }
          ]"
          placeholder="選んでください"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'list']" class="width-1x" />
          </template>
        </CSelect>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="boxId"
          type="text"
          label="箱番"
          placeholder="箱番"
          horizontal
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'boxes']" class="width-1x" />
          </template>
        </CInput>
      </div>

      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            入札結果
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group
              v-model="bidResultStatus"
              :list="BID_RESULT_STATUS_LIST"
              :name="'bidResultStatus'"
            />
          </CCol>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            状態
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group
              v-model="status"
              :list="ITEM_STATUS_LIST"
              :name="'status'"
            />
          </CCol>
        </div>
      </div>

      <div class="col-12 col-xl-6" />
    </div>

    <div class="box-form-footer form-group">
      <CButton
        type="submit"
        color="primary"
        :disabled="disabled || loading"
      >
        <font-awesome-icon :icon="['fas', 'search']" class="width-1x" />
        検索
      </CButton>
      &nbsp;
      <CButton
        color="secondary"
        :disabled="loading"
        @click="onClearFormSearch"
      >
        <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
        クリア
      </CButton>
    </div>
  </CForm>
</template>

<style lang="scss" scoped>
  .item-search-form {
    /deep/ {
      .col-form-label {
        text-align: right;
        @include mq(max_lg) {
          text-align: left;
        }
      }
      .box-form-footer {
        text-align: center;
        .btn {
          min-width: 100px;
        }
      }
    }
  }
</style>

<script>
import { isEqual } from 'lodash'

import {
  ITEM_STATUS_LIST,
  BID_RESULT_STATUS_LIST
} from '~/constants'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const EVENT_SUBMIT = 'submit'

export default {
  components: {
    AppRadioGroup
  },

  props: {
    /**
     * Default condition
     */
    defaultCondition: {
      type: Object,
      default: () => {}
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      // Form search
      boxId: null,
      category: null,
      type: null,
      status: 0,
      bidResultStatus: 0,

      // Previous codition
      prevCondition: null
    }
  },

  computed: {
    /**
     * Get ITEM_STATUS_LIST
     *
     * @return {Array} ITEM_STATUS_LIST
     */
    ITEM_STATUS_LIST () {
      const allItem = [
        {
          id: 0,
          name: 'All'
        }
      ]

      const list = ITEM_STATUS_LIST.map((item) => {
        return {
          id: item.id,
          name: item.name,
          value: item.id
        }
      })

      return allItem.concat(list)
    },

    /**
     * Get BID_RESULT_STATUS_LIST
     *
     * @return {Array} BID_RESULT_STATUS_LIST
     */
    BID_RESULT_STATUS_LIST () {
      const allItem = [
        {
          id: 0,
          name: 'All'
        }
      ]

      const list = BID_RESULT_STATUS_LIST.map((item) => {
        return {
          id: item.id,
          name: item.name,
          value: item.id
        }
      })

      return allItem.concat(list)
    },

    /**
     * Check disable status of button search
     *
     * @return {Boolean} Disable status of button search
     */
    disabled () {
      if (this.prevCondition === null) {
        return false
      }

      return isEqual(this.prevCondition, this.condition)
    },

    /**
     * Get condition input on form
     *
     * @return {Object} Condition
     */
    condition () {
      const condition = {}

      if (this.boxId) {
        condition.boxId = this.boxId
      }

      if (this.category) {
        condition.category = this.category
      }

      if (this.type) {
        condition.type = this.type
      }

      if (this.status) {
        condition.status = this.status
      }

      if (this.bidResultStatus) {
        condition.bidResultStatus = this.bidResultStatus
      }

      return condition
    }
  },

  methods: {
    /**
     * Clean all condition data on form
     */
    onClearFormSearch () {
      this.boxId = null
      this.category = null
      this.type = null
      this.status = 0
      this.bidResultStatus = 0
    },

    /**
     * Check validate input
     * If valid then show error
     * Else call submit event
     */
    onSubmit () {
      this.prevCondition = this.condition
      this.$emit(EVENT_SUBMIT, this.condition)
    }
  }
}
</script>
